package kge.utils;

import kha.Blob;
import kge.math.Rectangle;

class AtlasFrame {
	public var name:String;
	public var rectangle:Rectangle;
	
	public function new(name:String, rectangle:Rectangle) {
		this.name = name;
		this.rectangle = rectangle;
	}
	
	public function toString() {
		return "{name: " + name + ", rectangle: " + rectangle + "}"; 
	}
}

class AtlasSheet {
	public var frames:Map<String, AtlasFrame>;

    public function new(xml:Xml) {
		var subtextures = xml.elementsNamed("TextureAtlas").next().elementsNamed("SubTexture");
		
		frames = new Map();
		
		for (sub in subtextures) {
			var name:String = sub.get("name");
			frames.set(name, new AtlasFrame(name, new Rectangle(
				Std.parseFloat(sub.get("x")),
				Std.parseFloat(sub.get("y")),
				Std.parseFloat(sub.get("width")),
				Std.parseFloat(sub.get("height"))
			)));
		}
	}
	
	public function toString() {
		var string:String = "[\n";
		for (frame in frames) {
			string += frame.toString() + "," + "\n";
		}
		string += "]";
		return string;
	}
}

class XMLParser
{

	public static function parse(data:Blob):Xml {
		return Xml.parse(data.toString());
	}
	
	public static function parseXMLAtlas(data:Blob):AtlasSheet {
		return new AtlasSheet(parse(data));
	}
	
}